=== deps/memkind/Makefile ===
export JE_PREFIX=jemk_

.PHONY: all
all: 
	cd src;	./build_jemalloc.sh
	cd src; ./build.sh

.PHONY: clean
clean:
	cd src; make clean
