=== debian/changelog ===
keydb (6.3.4-0.1sipwise1~bpo13+5) trixie-backports; urgency=medium

  * Fix crash in freeClient() when c->bpop.keys has already been released.

 -- Guillem Jover <gjover@sipwise.com>  Fri, 06 Jun 2025 12:58:26 +0200

keydb (6.3.4-0.1sipwise1~bpo13+4) trixie-backports; urgency=medium

  * Rebuild against current trixie, incl. librocksdb9.8 /
    librocksdb9.10 change.

 -- Michael Prokop <mprokop@sipwise.com>  Tue, 25 Feb 2025 13:18:33 +0100

keydb (6.3.4-0.1sipwise1~bpo13+3) trixie-backports; urgency=medium

  * Set systemd service type to notify.
  * Fix crash in replicationCacheMaster() expecting a nullptr cached_master.

 -- Guillem Jover <gjover@sipwise.com>  Tue, 11 Feb 2025 18:36:38 +0100

keydb (6.3.4-0.1sipwise1~bpo13+2) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.
  * Do not install service files into non-canonical pathnames.

 -- Guillem Jover <gjover@sipwise.com>  Mon, 16 Sep 2024 18:10:09 +0200

keydb (6.3.4-0.1sipwise1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.
  * Adapt system RocksDB patch to version in Debian trixie.
  * Switch gbp.conf to sipwise/trixie.

 -- Guillem Jover <gjover@sipwise.com>  Fri, 13 Sep 2024 14:06:23 +0200

keydb (6.3.4-0.1sipwise1~bpo12+2) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Do not use the system jemalloc for now (to keep memory defrag support).

 -- Guillem Jover <gjover@sipwise.com>  Fri, 05 Apr 2024 20:41:17 +0200

keydb (6.3.4-0.1sipwise1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * New upstream version.
  * Stop using pristine-tar.
  * Use debian/watch version 4 instead of unknown version 6.
  * Fix upstream tarball URL in debian/watch.
  * Switch to use the system libjemalloc-dev.
  * Switch to use the system librocksdb-dev.
  * Add missing shared library dependencies to server and client packages.
  * Set Sipwise Development Team as maintainer.

 -- Guillem Jover <gjover@sipwise.com>  Fri, 15 Mar 2024 23:45:24 +0100

keydb (6.3.3-0.1sipwise1~bpo12+2) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Move keydb-server and keydb-sentinel to their actual package, and add
    Breaks and Replaces to make a smooth upgrade, when moving the files
    around packages.
  * Disable motd support for both the server and the CLI.
  * Run wrap-and-sort -sat.
  * Remove unneeded or implicit Build-Depends.
  * Remove <!nocheck> profile from non-test build dependencies.
  * Remove explicit parallel DEB_BUILD_OPTIONS handling, done by debhelper.
  * Move dh_installsystemd call into its own override.
  * Switch from a dh_auto_clean override into debian/clean.
  * Use spaces around assignment operator in make variables.
  * Switch from /var/run to /run.
  * Split Documentation systemd unit directive entries per line.

 -- Guillem Jover <gjover@sipwise.com>  Fri, 01 Dec 2023 19:49:46 +0100

keydb (6.3.3-0.1~bpo12+2) bookworm-backports; urgency=medium

  [ Victor Seva ]
  * debian: gitbuildpackage config

  [ Michael Prokop ]
  * Debian packaging: avoid failure when running without systemd

 -- Victor Seva <vseva@debian.org>  Thu, 22 Jun 2023 15:07:31 +0200

keydb (6.3.3-0.1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Michael Prokop <mprokop@sipwise.com>  Wed, 21 Jun 2023 18:04:39 +0200

keydb (6.3.3-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream version (packaging generated via upstream's
    pkg/deb//deb-buildsource.sh script).

 -- Michael Prokop <mprokop@sipwise.com>  Wed, 21 Jun 2023 18:02:15 +0200

keydb (5:5.3.3-1~bionic1) bionic; urgency=medium

  * 5.3.3 Updating deb source package and naming convention.

 -- Ben Schermel <ben@eqalpha.com>  Fri, 25 Oct 2019 8:00:37 +0000

keydb (5:5.1.12-1chl1~bionic1) bionic; urgency=medium

  * 5.1.1 update. This update fixes several rare deadlock scenarios. Deadlock detection is also added.  

 -- Ben Schermel <ben@eqalpha.com>  Fri, 25 Oct 2019 8:00:37 +0000

keydb (5:5.1.11-1chl1~bionic1) bionic; urgency=medium

  * 5.1 release. This release includes subkey expires (EXPIREMEMBER/EXPIREMEMBERAT), with updates to PTTL/TTL accordingly. New OBJECT LASTMODIFIED, BITIOP LSHIFT & BITOP RSHIFT commands. See https://docs.keydb.dev/blog/2019/10/20/blog-post/ for detailed review of release.

 -- Ben Schermel <ben@eqalpha.com>  Mon, 21 Oct 2019 8:00:37 +0000

keydb (5:5.0.1-1chl1~bionic1) bionic; urgency=medium

  * Arm build now included for bionic package

 -- Ben Schermel <ben@eqalpha.com>  Wed, 21 Aug 2019 22:58:37 +0000

keydb (5:5.0.0-1chl1~bionic1) bionic; urgency=medium

  * Initial release of KeyDB PPA. This PPA was originally derived from https://launchpad.net/~chris-lea/+archive/ubuntu/redis-server

 -- Ben Schermel <ben@eqalpha.com>  Wed, 21 Aug 2019 2:58:37 +0000
