=== debian/control ===
Source: keydb
Section: database
Priority: optional
Maintainer: Sipwise Development Team <support@sipwise.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libbz2-dev,
 libcurl4-openssl-dev,
 liblz4-dev,
 librocksdb-dev,
 libsnappy-dev,
 libssl-dev,
 libsystemd-dev,
 libzstd-dev,
 nasm,
 pkg-config,
 procps <!nocheck>,
 tcl <!nocheck>,
 tcl-dev <!nocheck>,
 uuid-dev,
 zlib1g-dev,
Standards-Version: 4.2.1
Homepage: https://docs.keydb.dev/
Vcs-Git: https://github.com/Snapchat/KeyDB.git
Vcs-Browser: https://github.com/Snapchat/KeyDB

Package: keydb
Architecture: all
Depends:
 keydb-server (<< ${binary:Version}.1~),
 keydb-server (>= ${binary:Version}),
 ${misc:Depends},
Description: Persistent key-value database with network interface (metapackage)
 keydb is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. keydb additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.
 .
 This package depends on the keydb-server package.

Package: keydb-sentinel
Architecture: any
Depends:
 keydb-tools (= ${binary:Version}),
 lsb-base (>= 3.2-14),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 keydb-tools (<< 6.3.3-0.1sipwise1~bpo12+2~),
Replaces:
 keydb-tools (<< 6.3.3-0.1sipwise1~bpo12+2~),
Description: Persistent key-value database with network interface (monitoring)
 keydb is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. keydb additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the keydb Sentinel monitoring software.

Package: keydb-server
Architecture: any
Depends:
 keydb-tools (= ${binary:Version}),
 lsb-base (>= 3.2-14),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 keydb-tools (<< 6.3.3-0.1sipwise1~bpo12+2~),
Replaces:
 keydb-tools (<< 6.3.3-0.1sipwise1~bpo12+2~),
Description: Persistent key-value database with network interface
 keydb is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. keydb additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.

Package: keydb-tools
Architecture: any
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 keydb-sentinel (<< 6.3.3-0.1sipwise1~bpo12+2~),
 keydb-server (<< 6.3.3-0.1sipwise1~bpo12+2~),
Description: Persistent key-value database with network interface (client)
 keydb is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. keydb additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the command line client and other tools.
