=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildflags.mk

export BUILD_TLS = yes
export USE_SYSTEMD = yes
export NO_MOTD = yes
export ENABLE_FLASH = yes
export CFLAGS CPPFLAGS LDFLAGS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -ldl -latomic $(LUA_LDFLAGS)

%:
	dh $@

override_dh_auto_install:
	debian/bin/generate-systemd-service-files

override_dh_installsystemd:
	dh_installsystemd --restart-after-upgrade

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Avoid race conditions in upstream testsuite.
	./runtest || true
	./runtest-cluster || true
	./runtest-sentinel || true
endif

override_dh_compress:
	dh_compress -Xredis-trib.rb

override_dh_installchangelogs:
	dh_installchangelogs --keep 00-RELEASENOTES
